/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage");
dojo.require('epages.widget.LocalizedWidget');
dojo.require("dojo.number");

dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		maxGallerySize         : 0.0,
		currentGallerySize     : 0.0,
		unitString             : 'MB',
		usageTextClass         : undefined,

		/**
		 * widget properties
		 */
		percentageClass        : 'PercentageNormal',
		templateString:"<p>{MemoryUsage}\n    <span dojoAttachPoint=\"statusBar\" class=\"StatusBar LeftMargin TopSmallMargin AlignLeft\" style=\"width: 70px\" title=\"{TotalMemory}: 0 MB / {UsedMemory}: 0 MB\" >\n      <span class=\"InnerStatusBar\">\n      <span dojoAttachPoint=\"percentageClassNode\" class=\"${percentageClass}\" style=\"width:0%\"></span>\n    </span>\n  </span>\n  <span dojoAttachPoint=\"usageTextPercentage\"></span><span dojoAttachPoint=\"usageText\"></span>\n</p>\n",
		translationName        : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget','templates/translation'),

		postCreate: function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.id+'/updateCurrentBytes', this, 'updateCurrentBytes');
		},

		updateUsage : function(/* Object */ usageData) {
		 // summary: Write gallery usage data to class members and update widget.
			this.maxGallerySize     = parseFloat(usageData.maxGallerySize);
			this.currentGallerySize = parseFloat(usageData.currentGallerySize);
			this._updateWidget();
		},

		updateCurrentBytes : function (/* Integer */ kilobytes) {
		 // summary: Change the current gallery usage and update the widget.
			this.currentGallerySize = parseFloat(kilobytes);
			this._updateWidget();
		},

		_updateWidget : function() {
		 // summary: Compose strings with usage percentage, max gallery size and current gallery size
		 //   and update the widget's template attach points.
			var percentage = 100 * this.currentGallerySize / this.maxGallerySize;
			if(percentage > 100) {
				percentage = 100.0;
			}
			var tmpCurrentSize = this.currentGallerySize;
			var tmpMaxSize = this.maxGallerySize;
			if(tmpCurrentSize > tmpMaxSize) {
				tmpCurrentSize = tmpMaxSize;
			}
			var displayPercentageNoDec = dojo.number.round(percentage, 0).toString() + '%';

			var displayCurrentValue = dojo.number.round(tmpCurrentSize/1024,0).toString();
			var displayMaxValue = dojo.number.round(tmpMaxSize/1024,0).toString();
			var displayFreeMemory = dojo.number.round((tmpMaxSize - tmpCurrentSize)/1024,0).toString();

			if(percentage > 90.0) {
				this.percentageClass = 'PercentageCritical';
			} else if(percentage > 60.0) {
				this.percentageClass = 'PercentageMiddle';
			} else {
				this.percentageClass = 'PercentageNormal';
			}

			dojo.attr(this.percentageClassNode, 'class', this.percentageClass);
			dojo.attr(this.percentageClassNode, 'style', { 'width' : displayPercentageNoDec });

			if(this.usageTextClass != undefined) {
				dojo.removeClass(this.usageText);
				dojo.addClass(this.usageText, this.usageTextClass);
			}
			this.statusBar.title = this.translate('TotalMemory') + ': ' + displayMaxValue + ' ' + this.unitString + ' / ' + this.translate('UsedMemory') + ': ' + displayCurrentValue + ' ' + this.unitString;
			this.usageTextPercentage.innerHTML = displayPercentageNoDec + '&nbsp;';
			this.usageText.innerHTML = this.translate('FreeMemory')+ ': ' + displayFreeMemory + ' ' + this.unitString;
		}

});

}
