/*global define,window*/
define([
    'testsuite/qunit',
    'jquery',
    'ep',
    'testsuite/qunit-fixture!de_epages/easymarketing/ui/easymarketingdialoguninstallapp-test',
    'de_epages/easymarketing/ui/easymarketingdialoguninstallapp'
], function(QUnit, $, ep, fixture, easymarketingdialoguninstallapp) {

    'use strict';
    QUnit.module('de_epages/easymarketingt/ui/easymarketingdialoguninstallapp', {
        setup: fixture.init,
        teardown: fixture.destroy
    });
//
    QUnit.test('Check if the behaviour of uninstall app is as expected ', 2, function() {

        ep.ajax = function(o) {
            var result = $.Deferred();

            result.resolve({
                "status": "ok",
                "message": "",
            });

            return result;
        };

        this.mockWindow = {
            location: {}
        };

        var UninstallAppButton = $('#CaptureLink');
        easymarketingdialoguninstallapp( UninstallAppButton, "12345", this.mockWindow );

        UninstallAppButton.trigger('click');
        $('#YesId').trigger('click');

        QUnit.strictEqual(
                $("#Response").html(),
                'OK',
                'Check that the value of the dialog is the expected for a properly execution. We are waiting for the word OK at the dialog'
        );

        QUnit.strictEqual(
            this.mockWindow.location.href,
            '?ViewAction=MBO-ViewEasyMarketing',
            'Window.location should be changed to the ViewAction MBO-ViewEasyMarketing'
        );

    });
});
